Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 2333)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 2334)
@@ -2,9 +2,10 @@
    !!======================================================================
    !!                       ***  MODULE  diahsb  ***
-   !! Ocean diagnostics: Heat salt and volume budgets
+   !! Ocean diagnostics: Heat, salt and volume budgets
    !!======================================================================
-   !! History :  NEMO 3.3  !  2010-09  (M. Leclair)  Original code 
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !! History :  3.3  ! 2010-09  (M. Leclair)  Original code 
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
@@ -22,11 +23,9 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC dia_hsb        ! routine called by step.F90
-   PUBLIC dia_hsb_init   ! routine called by opa.F90
-
-   LOGICAL , PUBLIC ::   ln_diahsb  = .FALSE.   !: check the heat and salt budgets
-
-   !! * Module variables
+   PUBLIC   dia_hsb        ! routine called by step.F90
+   PUBLIC   dia_hsb_init   ! routine called by opa.F90
+
+   LOGICAL, PUBLIC ::   ln_diahsb  = .FALSE.   !: check the heat and salt budgets
+
    INTEGER                                 ::   numhsb                           !
    REAL(dp)                                ::   surf_tot   , vol_tot             !
@@ -45,5 +44,5 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -54,11 +53,10 @@
       !!                  ***  ROUTINE dia_hsb  ***
       !!     
-      !! ** Purpose: Compute the ocean global heat content, salt content and volume
-      !!             non conservation
+      !! ** Purpose: Compute the ocean global heat content, salt content and volume conservation
       !!	
       !! ** Method : - Compute the deviation of heat content, salt content and volume
-      !!	       at the current time step from their values at nit000
-      !!	     - Compute the contribution of forcing and remove it from these
-      !!                deviations
+      !!	            at the current time step from their values at nit000
+      !!	            - Compute the contribution of forcing and remove it from these deviations
+      !!
       !! ** Action : Write the results in the 'heat_salt_volume_budgets.txt' ASCII file
       !!---------------------------------------------------------------------------
@@ -82,9 +80,7 @@
       z_frc_trd_s =           SUM( sbc_tsc(:,:,jp_sal) * surf(:,:) )     ! salt fluxes
       ! Add penetrative solar radiation
-      IF( ln_traqsr ) z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qsr     (:,:) * surf(:,:) )
-#if defined key_trabbc
+      IF( ln_traqsr )   z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qsr     (:,:) * surf(:,:) )
       ! Add geothermal heat flux
-      IF( lk_trabbc ) z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qgh_trd0(:,:) * surf(:,:) )
-#endif
+      IF( ln_trabbc )   z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qgh_trd0(:,:) * surf(:,:) )
       IF( lk_mpp ) THEN
          CALL mpp_sum( z_frc_trd_v )
@@ -143,6 +139,7 @@
 
 9020  FORMAT(I5,11D15.7)
-
+      !
    END SUBROUTINE dia_hsb
+
 
    SUBROUTINE dia_hsb_init
@@ -161,11 +158,11 @@
       INTEGER            ::   jk       ! dummy loop indice
       INTEGER            ::   ierror   ! local integer
-
+      !!
       NAMELIST/namhsb/ ln_diahsb
       !!----------------------------------------------------------------------
-
+      !
       REWIND ( numnam )              ! Read Namelist namhsb 
       READ   ( numnam, namhsb )
-
+      !
       IF(lwp) THEN                   ! Control print
          WRITE(numout,*)
@@ -175,5 +172,4 @@
          WRITE(numout,*) '      Switch for hsb diagnostic (T) or not (F)  ln_diahsb  = ', ln_diahsb
       ENDIF
-      !!---------------------------------------------------------------------------
 
       IF( .NOT. ln_diahsb )   RETURN
@@ -218,5 +214,5 @@
          vol_tot  = vol_tot + SUM( surf(:,:) * tmask(:,:,jk)     &
             &                      * fse3t_n(:,:,jk)         )
-      ENDDO
+      END DO
       IF( lk_mpp ) THEN 
          CALL mpp_sum( vol_tot )