Index: /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 2335)
+++ /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 2336)
@@ -307,20 +307,23 @@
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
 !-----------------------------------------------------------------------
-    filbdy_mask    =  ''                  !  name of mask file (if ln_bdy_mask=.TRUE.)
-    filbdy_data_T  = 'bdydata_grid_T.nc'  !  name of data file (T-points)
-    filbdy_data_U  = 'bdydata_grid_U.nc'  !  name of data file (U-points)
-    filbdy_data_V  = 'bdydata_grid_V.nc'  !  name of data file (V-points)
-    ln_bdy_clim    = .false.              !  contain 1 (T) or 12 (F) time dumps and be cyclic
-    ln_bdy_vol     = .true.               !  total volume correction (see volbdy parameter)
-    ln_bdy_mask    = .false.              !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
-    ln_bdy_tides   = .true.               !  Apply tidal harmonic forcing with Flather condition
-    ln_bdy_dyn_fla = .true.               !  Apply Flather condition to velocities
-    ln_bdy_tra_frs = .false.              !  Apply FRS condition to temperature and salinity 
-    ln_bdy_dyn_frs = .false.              !  Apply FRS condition to velocities
-    nbdy_dta       =  1                   !  = 0, bdy data are equal to the initial state
-                                          !  = 1, bdy data are read in 'bdydata   .nc' files
-    nb_rimwidth    = 9                    !  width of the relaxation zone
-    volbdy         = 0                    !  = 0, the total water flux across open boundaries is zero
-                                          !  = 1, the total volume of the system is conserved
+    cn_mask    =  ''                        !  name of mask file (if ln_bdy_mask=.TRUE.)
+    cn_dta_frs_T  = 'bdydata_grid_T.nc'     !  name of data file (T-points)
+    cn_dta_frs_U  = 'bdydata_grid_U.nc'     !  name of data file (U-points)
+    cn_dta_frs_V  = 'bdydata_grid_V.nc'     !  name of data file (V-points)
+    cn_dta_fla_T  = 'bdydata_bt_grid_T.nc'  !  name of data file for Flather condition (T-points)
+    cn_dta_fla_U  = 'bdydata_bt_grid_U.nc'  !  name of data file for Flather condition (U-points)
+    cn_dta_fla_V  = 'bdydata_bt_grid_V.nc'  !  name of data file for Flather condition (V-points)
+    ln_clim    = .false.                    !  contain 1 (T) or 12 (F) time dumps and be cyclic
+    ln_vol     = .false.                    !  total volume correction (see volbdy parameter)
+    ln_mask    = .false.                    !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
+    ln_tides   = .false.                    !  Apply tidal harmonic forcing with Flather condition
+    ln_dyn_fla = .false.                    !  Apply Flather condition to velocities
+    ln_tra_frs = .false.                    !  Apply FRS condition to temperature and salinity 
+    ln_dyn_frs = .false.                    !  Apply FRS condition to velocities
+    nn_rimwidth    =  9                     !  width of the relaxation zone
+    nn_dtactl      =  1                     !  = 0, bdy data are equal to the initial state
+                                            !  = 1, bdy data are read in 'bdydata   .nc' files
+    nn_volctl      =  0                     !  = 0, the total water flux across open boundaries is zero
+                                            !  = 1, the total volume of the system is conserved
 /
 !-----------------------------------------------------------------------
Index: /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 2335)
+++ /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 2336)
@@ -307,20 +307,23 @@
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
 !-----------------------------------------------------------------------
-    filbdy_mask    =  ''                  !  name of mask file (if ln_bdy_mask=.TRUE.)
-    filbdy_data_T  = 'bdydata_grid_T.nc'  !  name of data file (T-points)
-    filbdy_data_U  = 'bdydata_grid_U.nc'  !  name of data file (U-points)
-    filbdy_data_V  = 'bdydata_grid_V.nc'  !  name of data file (V-points)
-    ln_bdy_clim    = .false.              !  contain 1 (T) or 12 (F) time dumps and be cyclic
-    ln_bdy_vol     = .true.               !  total volume correction (see volbdy parameter)
-    ln_bdy_mask    = .false.              !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
-    ln_bdy_tides   = .true.               !  Apply tidal harmonic forcing with Flather condition
-    ln_bdy_dyn_fla = .true.               !  Apply Flather condition to velocities
-    ln_bdy_tra_frs = .false.              !  Apply FRS condition to temperature and salinity 
-    ln_bdy_dyn_frs = .false.              !  Apply FRS condition to velocities
-    nbdy_dta       =  1                   !  = 0, bdy data are equal to the initial state
-                                          !  = 1, bdy data are read in 'bdydata   .nc' files
-    nb_rimwidth    = 9                    !  width of the relaxation zone
-    volbdy         = 0                    !  = 0, the total water flux across open boundaries is zero
-                                          !  = 1, the total volume of the system is conserved
+    cn_mask    =  ''                        !  name of mask file (if ln_bdy_mask=.TRUE.)
+    cn_dta_frs_T  = 'bdydata_grid_T.nc'     !  name of data file (T-points)
+    cn_dta_frs_U  = 'bdydata_grid_U.nc'     !  name of data file (U-points)
+    cn_dta_frs_V  = 'bdydata_grid_V.nc'     !  name of data file (V-points)
+    cn_dta_fla_T  = 'bdydata_bt_grid_T.nc'  !  name of data file for Flather condition (T-points)
+    cn_dta_fla_U  = 'bdydata_bt_grid_U.nc'  !  name of data file for Flather condition (U-points)
+    cn_dta_fla_V  = 'bdydata_bt_grid_V.nc'  !  name of data file for Flather condition (V-points)
+    ln_clim    = .false.                    !  contain 1 (T) or 12 (F) time dumps and be cyclic
+    ln_vol     = .false.                    !  total volume correction (see volbdy parameter)
+    ln_mask    = .false.                    !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
+    ln_tides   = .false.                    !  Apply tidal harmonic forcing with Flather condition
+    ln_dyn_fla = .false.                    !  Apply Flather condition to velocities
+    ln_tra_frs = .false.                    !  Apply FRS condition to temperature and salinity 
+    ln_dyn_frs = .false.                    !  Apply FRS condition to velocities
+    nn_rimwidth    =  9                     !  width of the relaxation zone
+    nn_dtactl      =  1                     !  = 0, bdy data are equal to the initial state
+                                            !  = 1, bdy data are read in 'bdydata   .nc' files
+    nn_volctl      =  0                     !  = 0, the total water flux across open boundaries is zero
+                                            !  = 1, the total volume of the system is conserved
 /
 !-----------------------------------------------------------------------
Index: /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2335)
+++ /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2336)
@@ -351,20 +351,23 @@
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
 !-----------------------------------------------------------------------
-    filbdy_mask    =  ''                  !  name of mask file (if ln_bdy_mask=.TRUE.)
-    filbdy_data_T  = 'bdydata_grid_T.nc'  !  name of data file (T-points)
-    filbdy_data_U  = 'bdydata_grid_U.nc'  !  name of data file (U-points)
-    filbdy_data_V  = 'bdydata_grid_V.nc'  !  name of data file (V-points)
-    ln_bdy_clim    = .false.              !  contain 1 (T) or 12 (F) time dumps and be cyclic
-    ln_bdy_vol     = .true.               !  total volume correction (see volbdy parameter)
-    ln_bdy_mask    = .false.              !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
-    ln_bdy_tides   = .true.               !  Apply tidal harmonic forcing with Flather condition
-    ln_bdy_dyn_fla = .true.               !  Apply Flather condition to velocities
-    ln_bdy_tra_frs = .false.              !  Apply FRS condition to temperature and salinity 
-    ln_bdy_dyn_frs = .false.              !  Apply FRS condition to velocities
-    nbdy_dta       =  1                   !  = 0, bdy data are equal to the initial state
-                                          !  = 1, bdy data are read in 'bdydata   .nc' files
-    nb_rimwidth    = 9                    !  width of the relaxation zone
-    volbdy         = 0                    !  = 0, the total water flux across open boundaries is zero
-                                          !  = 1, the total volume of the system is conserved
+    cn_mask    =  ''                        !  name of mask file (if ln_bdy_mask=.TRUE.)
+    cn_dta_frs_T  = 'bdydata_grid_T.nc'     !  name of data file (T-points)
+    cn_dta_frs_U  = 'bdydata_grid_U.nc'     !  name of data file (U-points)
+    cn_dta_frs_V  = 'bdydata_grid_V.nc'     !  name of data file (V-points)
+    cn_dta_fla_T  = 'bdydata_bt_grid_T.nc'  !  name of data file for Flather condition (T-points)
+    cn_dta_fla_U  = 'bdydata_bt_grid_U.nc'  !  name of data file for Flather condition (U-points)
+    cn_dta_fla_V  = 'bdydata_bt_grid_V.nc'  !  name of data file for Flather condition (V-points)
+    ln_clim    = .false.                    !  contain 1 (T) or 12 (F) time dumps and be cyclic
+    ln_vol     = .false                     !  total volume correction (see volbdy parameter)
+    ln_mask    = .false.                    !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
+    ln_tides   = .false.                    !  Apply tidal harmonic forcing with Flather condition
+    ln_dyn_fla = .false.                    !  Apply Flather condition to velocities
+    ln_tra_frs = .false.                    !  Apply FRS condition to temperature and salinity 
+    ln_dyn_frs = .false.                    !  Apply FRS condition to velocities
+    nn_rimwidth    =  9                     !  width of the relaxation zone
+    nn_dtactl      =  1                     !  = 0, bdy data are equal to the initial state
+                                            !  = 1, bdy data are read in 'bdydata   .nc' files
+    nn_volctl      =  0                     !  = 0, the total water flux across open boundaries is zero
+                                            !  = 1, the total volume of the system is conserved
 /
 !-----------------------------------------------------------------------
Index: /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist	(revision 2335)
+++ /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist	(revision 2336)
@@ -351,20 +351,23 @@
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
 !-----------------------------------------------------------------------
-    filbdy_mask    =  ''                  !  name of mask file (if ln_bdy_mask=.TRUE.)
-    filbdy_data_T  = 'bdydata_grid_T.nc'  !  name of data file (T-points)
-    filbdy_data_U  = 'bdydata_grid_U.nc'  !  name of data file (U-points)
-    filbdy_data_V  = 'bdydata_grid_V.nc'  !  name of data file (V-points)
-    ln_bdy_clim    = .false.              !  contain 1 (T) or 12 (F) time dumps and be cyclic
-    ln_bdy_vol     = .true.               !  total volume correction (see volbdy parameter)
-    ln_bdy_mask    = .false.              !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
-    ln_bdy_tides   = .true.               !  Apply tidal harmonic forcing with Flather condition
-    ln_bdy_dyn_fla = .true.               !  Apply Flather condition to velocities
-    ln_bdy_tra_frs = .false.              !  Apply FRS condition to temperature and salinity 
-    ln_bdy_dyn_frs = .false.              !  Apply FRS condition to velocities
-    nbdy_dta       =  1                   !  = 0, bdy data are equal to the initial state
-                                          !  = 1, bdy data are read in 'bdydata   .nc' files
-    nb_rimwidth    = 9                    !  width of the relaxation zone
-    volbdy         = 0                    !  = 0, the total water flux across open boundaries is zero
-                                          !  = 1, the total volume of the system is conserved
+    cn_mask    =  ''                        !  name of mask file (if ln_bdy_mask=.TRUE.)
+    cn_dta_frs_T  = 'bdydata_grid_T.nc'     !  name of data file (T-points)
+    cn_dta_frs_U  = 'bdydata_grid_U.nc'     !  name of data file (U-points)
+    cn_dta_frs_V  = 'bdydata_grid_V.nc'     !  name of data file (V-points)
+    cn_dta_fla_T  = 'bdydata_bt_grid_T.nc'  !  name of data file for Flather condition (T-points)
+    cn_dta_fla_U  = 'bdydata_bt_grid_U.nc'  !  name of data file for Flather condition (U-points)
+    cn_dta_fla_V  = 'bdydata_bt_grid_V.nc'  !  name of data file for Flather condition (V-points)
+    ln_clim    = .false.                    !  contain 1 (T) or 12 (F) time dumps and be cyclic
+    ln_vol     = .false.                    !  total volume correction (see volbdy parameter)
+    ln_mask    = .false.                    !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
+    ln_tides   = .false.                    !  Apply tidal harmonic forcing with Flather condition
+    ln_dyn_fla = .false.                    !  Apply Flather condition to velocities
+    ln_tra_frs = .false.                    !  Apply FRS condition to temperature and salinity 
+    ln_dyn_frs = .false.                    !  Apply FRS condition to velocities
+    nn_rimwidth    =  9                     !  width of the relaxation zone
+    nn_dtactl      =  1                     !  = 0, bdy data are equal to the initial state
+                                            !  = 1, bdy data are read in 'bdydata   .nc' files
+    nn_volctl      =  0                     !  = 0, the total water flux across open boundaries is zero
+                                            !  = 1, the total volume of the system is conserved
 /
 !-----------------------------------------------------------------------
Index: /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 2335)
+++ /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 2336)
@@ -351,20 +351,23 @@
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
 !-----------------------------------------------------------------------
-    filbdy_mask    =  ''                  !  name of mask file (if ln_bdy_mask=.TRUE.)
-    filbdy_data_T  = 'bdydata_grid_T.nc'  !  name of data file (T-points)
-    filbdy_data_U  = 'bdydata_grid_U.nc'  !  name of data file (U-points)
-    filbdy_data_V  = 'bdydata_grid_V.nc'  !  name of data file (V-points)
-    ln_bdy_clim    = .false.              !  contain 1 (T) or 12 (F) time dumps and be cyclic
-    ln_bdy_vol     = .true.               !  total volume correction (see volbdy parameter)
-    ln_bdy_mask    = .false.              !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
-    ln_bdy_tides   = .true.               !  Apply tidal harmonic forcing with Flather condition
-    ln_bdy_dyn_fla = .true.               !  Apply Flather condition to velocities
-    ln_bdy_tra_frs = .false.              !  Apply FRS condition to temperature and salinity 
-    ln_bdy_dyn_frs = .false.              !  Apply FRS condition to velocities
-    nbdy_dta       =  1                   !  = 0, bdy data are equal to the initial state
-                                          !  = 1, bdy data are read in 'bdydata   .nc' files
-    nb_rimwidth    = 9                    !  width of the relaxation zone
-    volbdy         = 0                    !  = 0, the total water flux across open boundaries is zero
-                                          !  = 1, the total volume of the system is conserved
+    cn_mask    =  ''                        !  name of mask file (if ln_bdy_mask=.TRUE.)
+    cn_dta_frs_T  = 'bdydata_grid_T.nc'     !  name of data file (T-points)
+    cn_dta_frs_U  = 'bdydata_grid_U.nc'     !  name of data file (U-points)
+    cn_dta_frs_V  = 'bdydata_grid_V.nc'     !  name of data file (V-points)
+    cn_dta_fla_T  = 'bdydata_bt_grid_T.nc'  !  name of data file for Flather condition (T-points)
+    cn_dta_fla_U  = 'bdydata_bt_grid_U.nc'  !  name of data file for Flather condition (U-points)
+    cn_dta_fla_V  = 'bdydata_bt_grid_V.nc'  !  name of data file for Flather condition (V-points)
+    ln_clim    = .false.                    !  contain 1 (T) or 12 (F) time dumps and be cyclic
+    ln_vol     = .false.                    !  total volume correction (see volbdy parameter)
+    ln_mask    = .false.                    !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
+    ln_tides   = .false.                    !  Apply tidal harmonic forcing with Flather condition
+    ln_dyn_fla = .false.                    !  Apply Flather condition to velocities
+    ln_tra_frs = .false.                    !  Apply FRS condition to temperature and salinity 
+    ln_dyn_frs = .false.                    !  Apply FRS condition to velocities
+    nn_rimwidth    =  9                     !  width of the relaxation zone
+    nn_dtactl      =  1                     !  = 0, bdy data are equal to the initial state
+                                            !  = 1, bdy data are read in 'bdydata   .nc' files
+    nn_volctl      =  0                     !  = 0, the total water flux across open boundaries is zero
+                                            !  = 1, the total volume of the system is conserved
 /
 !-----------------------------------------------------------------------
Index: /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/POMME/EXP00/namelist
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/POMME/EXP00/namelist	(revision 2335)
+++ /branches/nemo_v3_3_beta/NEMOGCM/CONFIG/POMME/EXP00/namelist	(revision 2336)
@@ -352,20 +352,23 @@
 &nambdy        !  unstructured open boundaries                          ("key_bdy")
 !-----------------------------------------------------------------------
-    filbdy_mask    =  ''                  !  name of mask file (if ln_bdy_mask=.TRUE.)
-    filbdy_data_T  = 'bdydata_grid_T.nc'  !  name of data file (T-points)
-    filbdy_data_U  = 'bdydata_grid_U.nc'  !  name of data file (U-points)
-    filbdy_data_V  = 'bdydata_grid_V.nc'  !  name of data file (V-points)
-    ln_bdy_clim    = .false.              !  contain 1 (T) or 12 (F) time dumps and be cyclic
-    ln_bdy_vol     = .true.               !  total volume correction (see volbdy parameter)
-    ln_bdy_mask    = .false.              !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
-    ln_bdy_tides   = .true.               !  Apply tidal harmonic forcing with Flather condition
-    ln_bdy_dyn_fla = .true.               !  Apply Flather condition to velocities
-    ln_bdy_tra_frs = .false.              !  Apply FRS condition to temperature and salinity 
-    ln_bdy_dyn_frs = .false.              !  Apply FRS condition to velocities
-    nbdy_dta       =  1                   !  = 0, bdy data are equal to the initial state
-                                          !  = 1, bdy data are read in 'bdydata   .nc' files
-    nb_rimwidth    = 9                    !  width of the relaxation zone
-    volbdy         = 0                    !  = 0, the total water flux across open boundaries is zero
-                                          !  = 1, the total volume of the system is conserved
+    cn_mask    =  ''                        !  name of mask file (if ln_bdy_mask=.TRUE.)
+    cn_dta_frs_T  = 'bdydata_grid_T.nc'     !  name of data file (T-points)
+    cn_dta_frs_U  = 'bdydata_grid_U.nc'     !  name of data file (U-points)
+    cn_dta_frs_V  = 'bdydata_grid_V.nc'     !  name of data file (V-points)
+    cn_dta_fla_T  = 'bdydata_bt_grid_T.nc'  !  name of data file for Flather condition (T-points)
+    cn_dta_fla_U  = 'bdydata_bt_grid_U.nc'  !  name of data file for Flather condition (U-points)
+    cn_dta_fla_V  = 'bdydata_bt_grid_V.nc'  !  name of data file for Flather condition (V-points)
+    ln_clim    = .false.                    !  contain 1 (T) or 12 (F) time dumps and be cyclic
+    ln_vol     = .false.                    !  total volume correction (see volbdy parameter)
+    ln_mask    = .false.                    !  boundary mask from filbdy_mask (T) or boundaries are on edges of domain (F)
+    ln_tides   = .false.                    !  Apply tidal harmonic forcing with Flather condition
+    ln_dyn_fla = .false.                    !  Apply Flather condition to velocities
+    ln_tra_frs = .false.                    !  Apply FRS condition to temperature and salinity 
+    ln_dyn_frs = .false.                    !  Apply FRS condition to velocities
+    nn_rimwidth    =  9                     !  width of the relaxation zone
+    nn_dtactl      =  1                     !  = 0, bdy data are equal to the initial state
+                                            !  = 1, bdy data are read in 'bdydata   .nc' files
+    nn_volctl      =  0                     !  = 0, the total water flux across open boundaries is zero
+                                            !  = 1, the total volume of the system is conserved
 /
 !-----------------------------------------------------------------------