Index: branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ASM.tex
===================================================================
--- branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ASM.tex	(revision 2298)
+++ branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ASM.tex	(revision 2349)
@@ -16,16 +16,19 @@
 temperature, salinity, sea surface height, velocity and sea ice concentration. 
 These are read into the model from a file which may be produced by data assimilation. 
-This code is controlled by the namelist \np{nam\_asminc}. 
+This code is controlled by the namelist \textit{nam\_asminc}. 
 There is a brief description of all the namelist options provided. 
-To build the ASM code \np{key\_asminc} must be set.
+To build the ASM code \key{asminc} must be set.
 
 %===============================================================
 
-\subsection{Direct initialization}
+\section{Direct initialization}
+\label{ASM_DI}
 
-Direct initialization refers to the instantaneous correction
+Direct initialization (DI) refers to the instantaneous correction
 of the model background state using the analysis increment.
+DI is used when \np{ln\_asmdin} is set to true.
 
-\subsection{Incremental Analysis Updates}
+\section{Incremental Analysis Updates}
+\label{ASM_IAU}
 
 Rather than updating the model state directly with the analysis increment,
@@ -34,4 +37,5 @@
 is referred to as Incremental Analysis Updates (IAU) \citep{Bloom_al_MWR96}.
 IAU is a common technique used with 3D assimilation methods such as 3D-Var or OI.
+IAU is used when \np{ln\_asmiau} is set to true.
 
 With IAU, the model state trajectory in the assimilation window 
@@ -40,8 +44,7 @@
 for temperature, salinity, horizontal velocity and SSH
 as additional tendency terms to the prognostic equations:
-\begin{eqnarray}
+\begin{eqnarray}     \label{eq:wa_traj_iau}
 {\bf x}^{a}(t_{i}) = M(t_{i}, t_{0})[{\bf x}^{b}(t_{0})] 
 \; + \; F_{i} \delta \tilde{\bf x}^{a} 
-\label{eq:wa_traj_iau}
 \end{eqnarray}
 where $F_{i}$ is a weighting function defined such that $\sum_{i=1}^{N} F_{i}=1$. 
@@ -53,15 +56,11 @@
 In addition, two different weighting functions have been implemented.
 The first function employs constant weights, 
-\begin{eqnarray}
+\begin{eqnarray}    \label{eq:F1_i}
 F^{(1)}_{i}
 =\left\{ \begin{array}{ll}
-   0   & 
-   {\rm if} \; \; \; t_{i} < t_{m} \\
-   1/M & 
-   {\rm if} \; \; \; t_{m} < t_{i} \leq t_{n} \\
-   0  &
-   {\rm if} \; \; \; t_{i} > t_{n}
+   0     &    {\rm if} \; \; \; t_{i} < t_{m}                \\
+   1/M &    {\rm if} \; \; \; t_{m} < t_{i} \leq t_{n} \\
+   0     &    {\rm if} \; \; \; t_{i} > t_{n}
   \end{array} \right. 
-\label{eq:F1_i}
 \end{eqnarray}
 where $M = m-n$.
@@ -69,22 +68,17 @@
 weight in the centre of the sub-window, with the weighting reduced 
 linearly to a small value at the window end-points.
-\begin{eqnarray}
+\begin{eqnarray}     \label{eq:F2_i}
 F^{(2)}_{i}
 =\left\{ \begin{array}{ll}
-   0   & 
-   {\rm if} \; \; \; t_{i} < t_{m} \\
-   \alpha \, i & 
-   {\rm if} \; \; \; t_{m} \leq t_{i} \leq t_{M/2} \\
-   \alpha \, (M - i +1) & 
-   {\rm if} \; \; \; t_{M/2} < t_{i} \leq t_{n} \\
-   0  &
-   {\rm if} \; \; \; t_{i} > t_{n}
+   0                           &    {\rm if} \; \; \; t_{i}       <     t_{m}                        \\
+   \alpha \, i               &    {\rm if} \; \; \; t_{m}    \leq t_{i}    \leq   t_{M/2}   \\
+   \alpha \, (M - i +1) &    {\rm if} \; \; \; t_{M/2}  <    t_{i}    \leq   t_{n}       \\
+   0                            &   {\rm if} \; \; \; t_{i}        >    t_{n}
   \end{array} \right.
-\label{eq:F2_i}
 \end{eqnarray}
 where $\alpha^{-1} = \sum_{i=1}^{M/2} 2i$ and $M$ is assumed to be even. 
-The weights described by Eq.~(\ref{eq:F2_i}) provide a 
+The weights described by \eqref{eq:F2_i} provide a 
 smoother transition of the analysis trajectory from one assimilation cycle 
-to the next than that described by Eq.~(\ref{eq:F1_i}).
+to the next than that described by \eqref{eq:F1_i}.
 
 %==========================================================================
@@ -100,7 +94,5 @@
 %-------------------------------------------------------------------------------------------------------------
 
-\subsection{Assimilation increments file}
-
-The header of an assimilation increments file produced using \np{ncdump -h} is shown below
+The header of an assimilation increments file produced using \textit{ncdump~-h} is shown below
 
 \begin{alltt}